--- a/apt-pkg/contrib/mmap.cc
+++ b/apt-pkg/contrib/mmap.cc
@@ -160,7 +160,6 @@
    if ((Flags & UnMapped) == UnMapped)
       return true;
    
-#ifdef _POSIX_SYNCHRONIZED_IO   
    if ((Flags & ReadOnly) != ReadOnly)
    {
       if (SyncToFd != NULL)
@@ -170,11 +169,12 @@
       }
       else
       {
+#ifdef _POSIX_SYNCHRONIZED_IO   
 	 if (msync((char *)Base, iSize, MS_SYNC) < 0)
 	    return _error->Errno("msync", _("Unable to synchronize mmap"));
+#endif   
       }
    }
-#endif   
    return true;
 }
 									/*}}}*/
@@ -186,7 +186,6 @@
    if ((Flags & UnMapped) == UnMapped)
       return true;
    
-#ifdef _POSIX_SYNCHRONIZED_IO
    unsigned long long PSize = sysconf(_SC_PAGESIZE);
    if ((Flags & ReadOnly) != ReadOnly)
    {
@@ -198,11 +197,12 @@
       }
       else
       {
+#ifdef _POSIX_SYNCHRONIZED_IO
 	 if (msync((char *)Base+(unsigned long long)(Start/PSize)*PSize,Stop - Start,MS_SYNC) < 0)
 	    return _error->Errno("msync", _("Unable to synchronize mmap"));
+#endif   
       }
    }
-#endif   
    return true;
 }
 									/*}}}*/
